From 27779006a2b6826a24a920ffd7ec489358a17ed0 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Oct 06 2017 16:30:51 +0000
Subject: [PATCH 964/1001] Various minor refactoring


---

diff --git a/hubs/static/client/.babelrc b/hubs/static/client/.babelrc
index aa30d85..bfa2dab 100644
--- a/hubs/static/client/.babelrc
+++ b/hubs/static/client/.babelrc
@@ -1,9 +1,16 @@
 {
   "presets" : [["es2015", {"modules": false}], "react"],
-  "plugins": ["syntax-dynamic-import", "transform-object-rest-spread"],
+  "plugins": [
+    "syntax-dynamic-import",
+    "transform-object-rest-spread"
+  ],
   "env": {
     "test": {
-      "plugins": ["transform-es2015-modules-commonjs", "dynamic-import-node", "transform-object-rest-spread"]
+      "plugins": [
+        "transform-es2015-modules-commonjs",
+        "dynamic-import-node",
+        "transform-object-rest-spread",
+      ]
     }
   }
 }
diff --git a/hubs/static/client/app/core/App.js b/hubs/static/client/app/core/App.js
index 6c90b23..2fb30fc 100644
--- a/hubs/static/client/app/core/App.js
+++ b/hubs/static/client/app/core/App.js
@@ -1,32 +1,14 @@
 import React from 'react';
-import {
-  connect,
-  Provider
-  } from 'react-redux';
+import { Provider } from 'react-redux';
 import { IntlProvider } from 'react-intl';
-import * as Pages from "../core/Pages";
+import PageContainer from "./PageContainer";
 
 
-const PageContainer = connect(
-  (state) => ({pageName: state.ui.page})
-)(
-  (props) => {
-    if (!Pages[props.pageName]) {
-      console.error("No such page: " + props.pageName + ". Choose one of:", Object.keys(Pages).join(", "));
-      return null;
-    }
-    return React.createElement(Pages[props.pageName], {});
-  }
+const App = (props) => (
+  <Provider store={props.store}>
+    <IntlProvider locale={navigator.language}>
+      <PageContainer />
+    </IntlProvider>
+  </Provider>
 );
-
-
-const App = (props) => {
-  return (
-    <Provider store={props.store}>
-      <IntlProvider locale={navigator.language}>
-        <PageContainer />
-      </IntlProvider>
-    </Provider>
-  );
-}
 export default App;
diff --git a/hubs/static/client/app/core/PageContainer.js b/hubs/static/client/app/core/PageContainer.js
new file mode 100644
index 0000000..ddb5bf0
--- /dev/null
+++ b/hubs/static/client/app/core/PageContainer.js
@@ -0,0 +1,24 @@
+import React from 'react';
+import { connect } from 'react-redux';
+import * as Pages from "./Pages";
+
+
+const PageContainer = (props) => {
+  const Page = Pages[props.pageName];
+  if (!Page) {
+    throw new Error(
+      "No such page: " + props.pageName
+      + ". Choose one of:",
+      Object.keys(Pages).join(", ")
+    );
+  }
+  return (
+    <Page />
+  );
+}
+
+export default connect(
+  (state) => ({pageName: state.ui.page})
+)(
+  PageContainer
+);
diff --git a/hubs/static/client/app/core/store.js b/hubs/static/client/app/core/store.js
new file mode 100644
index 0000000..f04ec7f
--- /dev/null
+++ b/hubs/static/client/app/core/store.js
@@ -0,0 +1,21 @@
+import { createStore, applyMiddleware } from 'redux';
+import thunk from 'redux-thunk';
+import rootReducer from './reducers';
+
+
+let middleware = [
+  thunk
+]
+
+if (process.env.NODE_ENV === "development") {
+  const { logger } = require("redux-logger");
+  middleware.push(logger);
+}
+
+export default function getStore(initialState) {
+  return createStore(
+    rootReducer,
+    initialState,
+    applyMiddleware(...middleware)
+  );
+}
diff --git a/hubs/static/client/app/index.js b/hubs/static/client/app/index.js
new file mode 100644
index 0000000..f1c3824
--- /dev/null
+++ b/hubs/static/client/app/index.js
@@ -0,0 +1,13 @@
+import React from 'react';
+import ReactDOM from 'react-dom';
+import getStore from "./core/store";
+import App from "./core/App";
+
+
+export function setupPage(elementId, initialState) {
+  const store = getStore(initialState);
+  ReactDOM.render(
+    <App store={store} />,
+    document.getElementById(elementId)
+  );
+}
diff --git a/hubs/static/client/webpack.common.js b/hubs/static/client/webpack.common.js
index e060cd7..cdf4140 100644
--- a/hubs/static/client/webpack.common.js
+++ b/hubs/static/client/webpack.common.js
@@ -3,59 +3,63 @@ const path = require('path');
 const CleanWebpackPlugin = require('clean-webpack-plugin');
 
 const PATHS = {
-  app: path.join(__dirname, 'app'),
-  build: path.join(__dirname, '..', 'js', 'build')
+  app: path.resolve(path.join(__dirname, 'app')),
+  build: path.resolve(path.join(__dirname, '..', 'js', 'build'))
 };
 
 module.exports = {
-  entry: {
-    Hubs: path.join(PATHS.app, 'core', 'index.js'),
-  },
-  output: {
-    path: PATHS.build,
-    filename: '[name].js',
-    chunkFilename: '[name].[chunkhash:8].bundle.js',
-    publicPath: "/static/js/build/", // TODO: https://webpack.js.org/guides/public-path/
-    library: 'Hubs',
-  },
-  externals: {
-    'jquery': 'jQuery',
-    'react': 'React',
-    'react-dom': 'ReactDOM',
-  },
-  module: {
-    rules: [
-    {
-      test: /\.jsx?$/,
-      enforce: 'pre',
-      loader: 'eslint-loader',
-      options: {
-        emitWarning: true,
-      },
-      include : PATHS.app
+  paths: PATHS,
+  config: {
+    entry: [
+      'babel-polyfill',
+      path.join(PATHS.app, 'index.js')
+    ],
+    output: {
+      path: PATHS.build,
+      filename: '[name].js',
+      chunkFilename: '[name].[chunkhash:8].bundle.js',
+      publicPath: "/static/js/build/", // TODO: https://webpack.js.org/guides/public-path/
+      library: 'Hubs',
+    },
+    externals: {
+      'jquery': 'jQuery',
+      'react': 'React',
+      'react-dom': 'ReactDOM',
     },
-    {
-      test : /\.jsx?$/,
-      loader : 'babel-loader',
-      options: {
-        cacheDirectory: true,
+    module: {
+      rules: [
+      {
+        test: /\.jsx?$/,
+        enforce: 'pre',
+        loader: 'eslint-loader',
+        options: {
+          emitWarning: true,
+        },
+        include : PATHS.app
+      },
+      {
+        test : /\.jsx?$/,
+        loader : 'babel-loader',
+        options: {
+          cacheDirectory: true,
+        },
+        exclude: /node_modules/,
+        include : PATHS.app
       },
-      exclude: /node_modules/,
-      include : PATHS.app
+      {
+        test: /\.(png|svg|jpg|gif)$/,
+        use: [ 'file-loader' ]
+      }
+      ]
     },
-    {
-      test: /\.(png|svg|jpg|gif)$/,
-      use: [ 'file-loader' ]
-    }
+    plugins: [
+      new CleanWebpackPlugin(
+        [PATHS.build], {
+          allowExternal: true,
+          exclude: ['.gitignore']
+        }
+      ),
+      new webpack.optimize.CommonsChunkPlugin("common"),
     ]
-  },
-  plugins: [
-    new CleanWebpackPlugin(
-      [PATHS.build], {
-        allowExternal: true,
-        exclude: ['.gitignore']
-      }
-    ),
-    new webpack.optimize.CommonsChunkPlugin("common")
-  ]
+  }
 };
diff --git a/hubs/static/client/webpack.dev.js b/hubs/static/client/webpack.dev.js
index 01164e2..56efa9e 100644
--- a/hubs/static/client/webpack.dev.js
+++ b/hubs/static/client/webpack.dev.js
@@ -1,7 +1,8 @@
+const webpack = require('webpack');
 const merge = require('webpack-merge');
 const common = require('./webpack.common.js');
 
-module.exports = merge(common, {
+module.exports = merge(common.config, {
   devtool: 'inline-source-map',
   module: {
     rules: [
@@ -14,4 +15,11 @@ module.exports = merge(common, {
     }
     ]
   },
+  plugins: [
+    new webpack.DefinePlugin({
+      'process.env': {
+        'NODE_ENV': JSON.stringify('development')
+      }
+    }),
+  ]
 });
diff --git a/hubs/static/client/webpack.prod.js b/hubs/static/client/webpack.prod.js
index 5db728b..2784ad9 100644
--- a/hubs/static/client/webpack.prod.js
+++ b/hubs/static/client/webpack.prod.js
@@ -23,12 +23,8 @@ module.exports = merge(common, {
       allChunks: true,
     }),
     new UglifyJSPlugin({
-      sourceMap: true
+      sourceMap: true,
+      comments: false
     }),
-    new webpack.DefinePlugin({
-      'process.env': {
-        'NODE_ENV': JSON.stringify('production')
-      }
-    })
   ]
 })
